# Reference

## Classes
* [`active_directory::dns_server`](#active_directorydns_server): 
* [`active_directory::domain_controller`](#active_directorydomain_controller): 
* [`active_directory::rsat_ad`](#active_directoryrsat_ad): 
* [`active_directory::rsat_dns`](#active_directoryrsat_dns): 
## Defined types
* [`active_directory::dns_ad_forewardzone`](#active_directorydns_ad_forewardzone): 
## Classes

### active_directory::dns_server

The active_directory::dns_server class.


#### Parameters

The following parameters are available in the `active_directory::dns_server` class.

##### `dns_server_name`

Data type: `String`



##### `bootmethod`

Data type: `Active_directory::Bootmethod`



Default value: '3'

##### `eventloglevel`

Data type: `Active_directory::Loglevels`



Default value: '4'

##### `addressanswerlimit`

Data type: `Active_directory::Addressanswerlimit`



Default value: '0'

##### `listening_addresses`

Data type: `String`



Default value: $facts['networking']['ip']

##### `roundrobin`

Data type: `Active_directory::Zero_one`



Default value: '1'

##### `allowupdate`

Data type: `Active_directory::Zero_one`



Default value: '1'

##### `enablednssec`

Data type: `Active_directory::Zero_one`



Default value: '1'

##### `enableednsprobes`

Data type: `Active_directory::Zero_one`



Default value: '1'

##### `forwarddelegations`

Data type: `Active_directory::Zero_one`



Default value: '0'

##### `autocacheupdate`

Data type: `Boolean`



Default value: `false`

##### `autoconfigfilezones`

Data type: `Integer`



Default value: 1

##### `forwardingtimeout`

Data type: `Integer`



Default value: 3

##### `bindsecondaries`

Data type: `Boolean`



Default value: `false`

##### `enabledirectorypartitions`

Data type: `Boolean`



Default value: `true`

##### `localnetpriority`

Data type: `Boolean`



Default value: `true`

##### `logfilemaxsize`

Data type: `Integer`



Default value: 500000000

##### `logfilepath`

Data type: `String`



Default value: '%SystemRoot%\System32\DNS\Dns.log'

##### `logipfilterlist`

Data type: `Optional[Variant[Array[String],String]]`



Default value: `undef`

##### `loosewildcarding`

Data type: `Boolean`



Default value: `false`

##### `maxcachettl`

Data type: `Integer`



Default value: 86400

##### `maxnegativecachettl`

Data type: `Integer`



Default value: 900

##### `namecheckflag`

Data type: `Integer`



Default value: 2

##### `norecursion`

Data type: `Boolean`



Default value: `false`

##### `recursionretry`

Data type: `Integer`



Default value: 3

##### `recursiontimeout`

Data type: `Integer`



Default value: 8

##### `rpcprotocol`

Data type: `Integer`



Default value: 5

##### `scavenginginterval`

Data type: `Integer`



Default value: 1

##### `secureresponses`

Data type: `Boolean`



Default value: `false`

##### `sendport`

Data type: `Integer`



Default value: 0

##### `strictfileparsing`

Data type: `Boolean`



Default value: `false`

##### `updateoptions`

Data type: `Integer`



Default value: 783

##### `writeauthorityns`

Data type: `Boolean`



Default value: `false`

##### `xfrconnecttimeout`

Data type: `Integer`



Default value: 30

##### `forwarders`

Data type: `Optional[String]`



Default value: `undef`


### active_directory::domain_controller

The active_directory::domain_controller class.


#### Parameters

The following parameters are available in the `active_directory::domain_controller` class.

##### `domain_credential_user`

Data type: `String`



##### `domain_credential_passwd`

Data type: `String`



##### `safe_mode_passwd`

Data type: `String`



##### `domain_name`

Data type: `String`



##### `parent_domain_name`

Data type: `Optional[String]`



Default value: `undef`

##### `parent_dns_addr`

Data type: `Optional[String]`



Default value: `undef`

##### `ad_db_path`

Data type: `String`



Default value: 'C:\Windows\NTDS'

##### `sysvol_path`

Data type: `String`



Default value: 'C:\Windows\SYSVOL'

##### `ad_log_path`

Data type: `String`



Default value: 'C:\Windows\NTDS'

##### `ad_creation_retry_attempts`

Data type: `String`



Default value: '5'

##### `ad_creation_retry_interval`

Data type: `String`



Default value: '5'

##### `ad_users`

Data type: `Optional[Hash]`



Default value: {}


### active_directory::rsat_ad

The active_directory::rsat_ad class.


### active_directory::rsat_dns

The active_directory::rsat_dns class.


## Defined types

### active_directory::dns_ad_forewardzone

The active_directory::dns_ad_forewardzone class.


#### Parameters

The following parameters are available in the `active_directory::dns_ad_forewardzone` defined type.

##### `domain_credential_user`

Data type: `String`



##### `domain_credential_passwd`

Data type: `String`



##### `replicationscope`

Data type: `Active_directory::Replicationscope`



Default value: 'Forest'

##### `dynamicupdate`

Data type: `Active_directory::Dynamicupdate`



Default value: 'Secure'

##### `directorypartitionname`

Data type: `Optional[String]`



Default value: `undef`


